package t1ck.widebase.db.table.mbt

import widebase.db.column. {

  DoubleColumn,
  DateTimeColumn,
  IntColumn,
  StringColumn
}

import widebase.db.table.Table

/** Column based quote table.
 *
 * @param table with quotes
 * @param symbolTable of quotes
 *
 * @author myst3r10n
 */
case class QuoteTable(table: Table, symbolTable: Table = null) {

  protected val symbolIndex =
    if(symbolTable == null)
      null
    else
      table("symbol").asInstanceOf[IntColumn]

  protected val symbolString =
    if(symbolTable == null)
      table("symbol").asInstanceOf[StringColumn]
    else
      symbolTable("symbol").asInstanceOf[StringColumn]

  /** Time column. */
  val time = table("time").asInstanceOf[DateTimeColumn]

  /** Bid column. */
  val bid = table("bid").asInstanceOf[DoubleColumn]

  /** Ask column. */
  val ask = table("ask").asInstanceOf[DoubleColumn]

  /** Records. */
  def records = table.records

  /** Symbol column. */
  def symbol(index: Int) =
    if(symbolTable == null)
      symbolString(index)
    else
      symbolString(symbolIndex(index))

}

